import * as React from 'react';
import { StyleProp, ViewStyle } from 'react-native';
import Animated from 'react-native-reanimated';
import { Props as HeaderContainerProps } from '../Header/HeaderContainer';
import { Route, HeaderScene, Layout, HeaderMode, NavigationProp, TransitionPreset } from '../../types';
declare type Props = TransitionPreset & {
    index: number;
    active: boolean;
    focused: boolean;
    closing: boolean;
    layout: Layout;
    current: Animated.Value<number>;
    previousScene?: HeaderScene<Route>;
    scene: HeaderScene<Route>;
    navigation: NavigationProp;
    cardTransparent?: boolean;
    cardOverlayEnabled?: boolean;
    cardShadowEnabled?: boolean;
    cardStyle?: StyleProp<ViewStyle>;
    gesturesEnabled?: boolean;
    getPreviousRoute: (props: {
        route: Route;
    }) => Route | undefined;
    renderHeader: (props: HeaderContainerProps) => React.ReactNode;
    renderScene: (props: {
        route: Route;
    }) => React.ReactNode;
    onOpenRoute: (props: {
        route: Route;
    }) => void;
    onCloseRoute: (props: {
        route: Route;
    }) => void;
    onGoBack: (props: {
        route: Route;
    }) => void;
    onTransitionStart?: (props: {
        route: Route;
        current: {
            index: number;
        };
        previous: {
            index: number;
        };
    }) => void;
    onTransitionEnd?: (props: {
        route: Route;
    }) => void;
    onGestureBegin?: () => void;
    onGestureCanceled?: () => void;
    onGestureEnd?: () => void;
    gestureResponseDistance?: {
        vertical?: number;
        horizontal?: number;
    };
    headerMode: HeaderMode;
    headerTransparent?: boolean;
    floatingHeaderHeight: number;
    hasCustomHeader: boolean;
};
export default class StackItem extends React.PureComponent<Props> {
    private handleOpen;
    private handleClose;
    private handleTransitionStart;
    render(): JSX.Element;
}
export {};
